package net.dries007.holoInventory.client.renderers;

import net.dries007.holoInventory.client.ClientEventHandler;
import net.minecraft.client.Minecraft;
import net.minecraft.client.multiplayer.WorldClient;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.RenderItem;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.tileentity.TileEntityRendererDispatcher;
import net.minecraft.client.resources.I18n;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.util.math.Vec3d;

import java.util.ArrayList;
import java.util.List;

public class InventoryRenderer implements IRenderer
{
    private final String name;
    private final List<ItemStack> stacks;

    public InventoryRenderer(String name, ItemStack[] input)
    {
        this.name = I18n.func_135052_a(name);

        this.stacks = new ArrayList<>(input.length);
        for (ItemStack stack : input)
        outer: {
            if (stack == null) continue;
            for (ItemStack stack2 : stacks)
            {
                if (!ItemStack.func_77970_a(stack, stack2) || !ItemStack.func_179545_c(stack, stack2)) continue;
                stack2.field_77994_a += stack.field_77994_a;
                break outer;
            }
            this.stacks.add(stack);
        }
    }

    @Override
    public void render(WorldClient worldClient, RayTraceResult ray, Vec3d pos)
    {
        if (stacks.size() == 0) return;
        Minecraft mc = Minecraft.func_71410_x();
        RenderManager rm = mc.func_175598_ae();
        RenderItem ri = mc.func_175599_af();

        GlStateManager.func_179094_E();
        GlStateManager.func_179123_a();

        GlStateManager.func_179091_B();
        GlStateManager.func_179141_d();
        GlStateManager.func_179092_a(516, 0.1F);
        GlStateManager.func_179147_l();
        GlStateManager.func_187401_a(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA);
        GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);

        try
        {
            GlStateManager.func_179137_b(pos.field_72450_a - TileEntityRendererDispatcher.field_147554_b, pos.field_72448_b - TileEntityRendererDispatcher.field_147555_c, pos.field_72449_c - TileEntityRendererDispatcher.field_147552_d);

            GlStateManager.func_179114_b(-rm.field_78735_i, 0.0F, 0.5F, 0.0F);
            GlStateManager.func_179114_b(rm.field_78732_j, 0.5F, 0.0F, 0.0F);
            GlStateManager.func_179137_b(0, 0, -0.5);

            double d = pos.func_72438_d(new Vec3d(TileEntityRendererDispatcher.field_147554_b, TileEntityRendererDispatcher.field_147555_c, TileEntityRendererDispatcher.field_147552_d));

            if (d < 1.75) return;
            GlStateManager.func_179139_a(d * 0.2, d * 0.2, d * 0.2);

            int cols;
            if (stacks.size() <= 9) cols = stacks.size();
            else if (stacks.size() <= 27) cols = 9;
            else if (stacks.size() <= 54) cols = 11;
            else if (stacks.size() <= 90) cols = 14;
            else if (stacks.size() <= 109) cols = 18;
            else cols = 21;
            int rows = 1 + ((stacks.size() % cols == 0) ? (stacks.size() / cols) - 1 : stacks.size() / cols);

            if (rows > 4) GlStateManager.func_179139_a(0.8, 0.8, 0.8);

            {
                GlStateManager.func_179094_E();
                GlStateManager.func_179123_a();
                GlStateManager.func_179114_b(180, 0, 0, 1);
                GlStateManager.func_179109_b(0, -0.4f * (1+rows/2)-0.2f, 0);
                //GlStateManager.translate(0, -1 - 0.5f * (rows/2.0), 0);
                GlStateManager.func_179139_a(0.03, 0.03, 0.03);
                int w = mc.field_71466_p.func_78256_a(name);
                mc.field_71466_p.func_78276_b(name,  -w/2, 0, 0xFFFFFF);
                GlStateManager.func_179099_b();
                GlStateManager.func_179121_F();
            }

            int r = 0;
            int c = 0;
            for (final ItemStack stack : stacks)
            {
                GlStateManager.func_179094_E();
                GlStateManager.func_179123_a();
                //RenderHelper.enableStandardItemLighting();

                GlStateManager.func_179137_b(0.4f * (cols / 2.0 - c) - 0.2f, 0.4f * (rows / 2.0 - r) - 0.2f, 0);
                if (++c == cols)
                {
                    r++;
                    c = 0;
                }
                GlStateManager.func_179094_E();
                GlStateManager.func_179114_b((float) (360.0 * (double) (System.currentTimeMillis() & 0x3FFFL) / (double) 0x3FFFL), 0, 1, 0);
                ri.func_181564_a(stack, ItemCameraTransforms.TransformType.GROUND);
                if (stack.func_77962_s())
                {
                    GlStateManager.func_179118_c();
                    GlStateManager.func_179101_C();
                    GlStateManager.func_179140_f();
                }
                GlStateManager.func_179121_F();
                {
                    GlStateManager.func_179094_E();
                    GlStateManager.func_179123_a();
                    GlStateManager.func_179114_b(180, 0, 0, 1);
                    GlStateManager.func_179137_b(0.2, 0, -0.1);
                    GlStateManager.func_179139_a(0.01, 0.01, 0.01);

                    String size = stack.field_77994_a < 1000 ? String.valueOf(stack.field_77994_a) : ClientEventHandler.DF.format(stack.field_77994_a / 1000.0);
                    int w = mc.field_71466_p.func_78256_a(size);
                    mc.field_71466_p.func_175063_a(size, -w, 0, ClientEventHandler.TEXTCOLOR);
                    GlStateManager.func_179099_b();
                    GlStateManager.func_179121_F();
                }

                //RenderHelper.disableStandardItemLighting();
                GlStateManager.func_179099_b();
                GlStateManager.func_179121_F();
            }

        }
        finally
        {
            GlStateManager.func_179118_c();
            GlStateManager.func_179101_C();
            GlStateManager.func_179140_f();

            GlStateManager.func_179099_b();
            GlStateManager.func_179121_F();
        }
    }
}
